#include <dos.h>
#include <io.h>
#include "graph.h"

// 
void GrpInit98(void)
{
	union REGS reg;
	short i,r,g,b;

	// 640x400
	reg.h.ah=0x42;
	reg.h.ch=0xc0;
	int86(0x18,&reg,&reg);

	outp(0x6a,1); // 16 color
	outp(0xa4,0); // display page 0
	outp(0xa6,0); // draw    page 0

	// G-ON
	reg.h.ah=0x40;
	int86(0x18,&reg,&reg);

	for(i=0; i<16; i++){
		g=(i&4?255:0);
		r=(i&2?255:0);
		b=(i&1?255:0);
		GrpPal98(i,g,r,b);
	}

	GrpCls98();
}

// I
void GrpTerm98(void)
{
	union REGS reg;

	GrpCls98();

	// G-OFF
	reg.h.ah=0x41;
	int86(0x18,&reg,&reg);
}

// ʃNA
void mem_clr98(unsigned short seg,unsigned short lng)
{
	char far *buf;
	FP_SEG(buf)=seg;
	FP_OFF(buf)=0;
	while(lng--) (*buf++)=0;
}
void GrpCls98(void)
{
	mem_clr98(0xa800,0x8000); // ڰ 0
	mem_clr98(0xb000,0x8000); // ڰ 1
	mem_clr98(0xb800,0x8000); // ڰ 2
	mem_clr98(0xe000,0x8000); // ڰ 3
}

// pbg
void GrpPal98(int n,int g,int r,int b)
{
	outp(0xa8,n); outp(0xaa,g);
	outp(0xac,r); outp(0xae,b);
}

// `mj \
void PutAnk98(short x,short y,short col,unsigned char *buff)
{
	static unsigned short tbl[]={ 0xa800,0xb000,0xb800,0xe000 };
	unsigned char far *vrm;
	short i,n,pag;

	for(pag=0; pag<4; pag++){
		FP_SEG(vrm)=tbl[pag];
		FP_OFF(vrm)=(y*16*80)+x;
		for(i=n=0; i<16; i++){
			if(col&1) vrm[0]=buff[n++];
			else      vrm[0]=0;
			FP_SEG(vrm)+=5;
		}
		col>>=1;
	}
}

//  \
void PutKnj98(short x,short y,short col,unsigned char *buff)
{
	static unsigned short tbl[]={ 0xa800,0xb000,0xb800,0xe000 };
	unsigned char far *vrm;
	short i,n,pag;

	for(pag=0; pag<4; pag++){
		FP_SEG(vrm)=tbl[pag];
		FP_OFF(vrm)=(y*16*80)+x;
		for(i=n=0; i<16; i++){
			if(col&1){ vrm[0]=buff[n++]; vrm[1]=buff[n++]; }
			else{      vrm[0]=0; vrm[1]=0; }
			FP_SEG(vrm)+=5;
		}
		col>>=1;
	}
}

// SHIFT-JIS -> JIS
unsigned short sj_js(unsigned short code)
{
	union {
		unsigned char b[2];
		unsigned short w;
	} p;
	#define code_hi p.b[1]
	#define code_lo p.b[0]
	#define code_wd p.w

	code_wd=code;

	if(     code_hi<0xa0) code_hi-=0x70;
	else if(code_hi<0xf0) code_hi-=0xb0;
	else return code;

	if(code_lo>=0x80) code_lo--;
	code_hi+=code_hi;

	if(code_lo>=0x9e) code_lo-=0x5e;
	else code_hi--;
	code_lo-=0x1f;

	return code_wd;
}

// tHgp^[̎擾
// code  0x00nn=1/4  0x80nn=ANK  0xnnnn=SHIFT-JIS
void GetFnt98(unsigned short code,unsigned char far *buff)
{
	union REGS r;
	struct SREGS s;
	static char tmp_buf[64];
	char far   *tmp_adr;
	unsigned short jis,i;

	i=(code>>8);
	if(     i==0x80) jis=code;
	else if(i==0x00) jis=code;
	else      jis=sj_js(code);

	segread(&s);
	tmp_adr=(char far *)(&tmp_buf[0]);
	r.h.ah=0x14; r.x.dx=jis;
	r.x.bx=FP_SEG(tmp_adr);
	r.x.cx=FP_OFF(tmp_adr);
	int86x(0x18,&r,&r,&s);

	for(i=0; i<32; i++) buff[i]=tmp_buf[i+2];
}

