#include <stdio.h>
#include <io.h>
#include <dos.h>
#include <fcntl.h>
#include "x1.h"
#include "x1_scpu.h"
#include "x1_crtc.h"
#include "x1_vram.h"
#include "x1_tape.h"

/***********************************************************************
	8255
***********************************************************************/

byte PORT_A=0xff;
byte PORT_B=0x01;
byte PORT_C=0xff;
byte MODE=0x82;

short init_8255(void)
{
	V_DISP=1;
	V_SYNC=0;
	MODE=0x82;

	return 0;
}

byte x1_8255_r(word Port)
{
	// if(MODE & 0x02){
		PORT_B=0x00;
		if(V_DISP      ) PORT_B|=0x80; // 0=\ 1=\
		if(SCPU_IBF    ) PORT_B|=0x40; // 0=SUB-CPUɃf[^𑗂Ă悢
		if(SCPU_OBF    ) PORT_B|=0x20; // 0=SUB-CPŨf[^L
		if(!ROM_SW     ) PORT_B|=0x10; // 0=ROM 1=RAM (Turbo Onry)
		/**************/ PORT_B|=0x08; // v^ BUSY
		if(V_SYNC      ) PORT_B|=0x04; // M
		if( cmt_read() ) PORT_B|=0x02; // ðߥް
		if(!cmt_test() ) PORT_B|=0x01; // 0=BREAK
	// }

	if(!IO_MODE) PORT_C|= 0x20;
	else         PORT_C&=~0x20;
	if(CRT_H320) PORT_C|= 0x40;
	else         PORT_C&=~0x40;

	SCPU_IBF=0;

	Port&=3;
	if(     Port==0) return PORT_A;
	else if(Port==1) return PORT_B;
	else if(Port==2) return PORT_C;
	else if(Port==3) return MODE;

	return 0xff;
}

void x1_8255_w(word Port,byte V)
{
	byte port_c,dmy;

	if(!IO_MODE) PORT_C|= 0x20;
	else         PORT_C&=~0x20;
	if(CRT_H320) PORT_C|= 0x40;
	else         PORT_C&=~0x40;
	port_c=PORT_C;

	Port&=3;
	if(       Port==0){
		if(!(MODE & 0x10)) PORT_A=V;
	} else if(Port==1){
		if(!(MODE & 0x02)) PORT_B=V;
	} else if(Port==2){
		if(!(MODE & 0x01)){ PORT_C&=0xf0; PORT_C|=(V&0x0f); }
		if(!(MODE & 0x08)){ PORT_C&=0x0f; PORT_C|=(V&0xf0); }
	} else if(Port==3){
		if(     V & 0x80) MODE=V;
		else if(V & 0x01){ Port=2; V=(V>>1)&7; PORT_C|= (1<<V); }
		else {             Port=2; V=(V>>1)&7; PORT_C&=~(1<<V); }
	}

	if(Port==2){
		/*
		// v^֑M
		if(JOY_TYPE==0){
			if(!(port_c & 0x80)){
				if(PORT_C & 0x80) fputc(PORT_A,stdprn);
			}
		}
		*/
		// ANZX[h̐؂ւ
		if(port_c & 0x20){
			if(!(PORT_C & 0x20)) IO_MODE=1;
		}

		// e[vւ̏
		cmt_write(PORT_C & 1);

		// SO^WO
		CRT_H320=(PORT_C & 0x40)?1:0;
		CRTC_REG.lng_flg=CRT_H320;
	}
}

